'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

///////////////////////////////////////// allLoad() /////////////////
/**
 * allLoad - zczytuje wszystkie configi: thisScriptCfg,
 *               commandCfg, globalCfg.
 * @return {[promise, promies, promise]}   array of promises:
 *                                         thisScriptCfg promsie,
 *                                         commandCfg promise,
 *                                         globalCfg promise.
 *
 */
var allLoad = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var arrOfProms;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return Promise.all([this.thisScriptLoad(), this.commandLoad(), this.globalLoad()]);

          case 3:
            arrOfProms = _context.sent;
            return _context.abrupt('return', arrOfProms);

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', 'q-mod-config - allLoad() error - ' + _context.t0);

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 7]]);
  }));

  return function allLoad() {
    return _ref.apply(this, arguments);
  };
}();

///////////////////////////////////////// facory cfg /////////////////


function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./q-mod-config-basic');

var simpleLoad = _require.simpleLoad;
var simpleLoadSync = _require.simpleLoadSync;
var remoteLoad = _require.remoteLoad;
var remoteLoadSync = _require.remoteLoadSync;
var show = _require.show;
var load = _require.load;
var loadSync = _require.loadSync;

var _require2 = require('./q-mod-config-generateCommandCfgLoadMsg');

var generateCommandCfgLoadMsg = _require2.generateCommandCfgLoadMsg;

var path = require('path');
var c = require('bragi');

// bragi logger
c.options.groupsEnabled = [
  // 'dev:simpleLoadCfg:cfg',
];

//////////////////////////////////////// thisScriptLoad////
var thisScriptLoad = function thisScriptLoad() {
  var folderNameThisScript = path.resolve(__dirname, this.relativePath);
  return remoteLoad(folderNameThisScript, this.cfgName).catch(function (err) {
    throw new Error('q-mod-config - thisScriptLoad() error - ' + err);
  });
};

///////////////////////////////////////// globalLoad() /////////////////
var globalLoad = function globalLoad() {
  return this.thisScriptLoad().then(function (res) {
    var globalPath = res.options.globalConfigPath;
    var cfgName = res.options.commandScriptConfigName;
    return remoteLoad(globalPath, cfgName);
  }).catch(function (err) {
    throw new Error('q-mod-config - globalLoad() error - ' + err);
  });
};

///////////////////////////////////////// commandLoad() /////////////////
var commandLoad = function commandLoad() {
  return this.thisScriptLoad().then(function (props) {
    var globalPath = props.options.globalConfigPath;
    var cfgName = props.options.commandScriptConfigName;
    return load(globalPath, cfgName);
  }).catch(function (err) {
    throw new Error('q-mod-config - commandLoad() error - ' + err);
  });
};var cfg = function cfg() {
  var cfgName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '.cfg';
  var relativePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '../../../';

  // '../../../' - bo docelowo node_modules/q-mode-config/dist/
  var options = {
    cfgName: cfgName,
    relativePath: relativePath
  };

  var cfgFns = {
    thisScriptLoad: thisScriptLoad,
    globalLoad: globalLoad,
    commandLoad: commandLoad,
    allLoad: allLoad
  };
  return Object.assign({}, options, cfgFns);
};

// module q-mod-config API:
module.exports = {
  // helpers
  generateCommandCfgLoadMsg: generateCommandCfgLoadMsg,
  // config-basic
  simpleLoad: simpleLoad,
  simpleLoadSync: simpleLoadSync,
  remoteLoad: remoteLoad,
  remoteLoadSync: remoteLoadSync,
  show: show,
  load: load,
  loadSync: loadSync,
  // index
  cfg: cfg
};