'use strict';

var _require = require('./q-mod-config-simple');

var simpleLoadCfg = _require.simpleLoadCfg;

var _require2 = require('./q-mod-config-remote');

var remoteLoadCfg = _require2.remoteLoadCfg;

var _require3 = require('./q-mod-config-load');

var loadCfg = _require3.loadCfg;

var _require4 = require('./q-mod-config-show');

var showRawCfg = _require4.showRawCfg;

var c = require('bragi');

// bragi logger
c.options.groupsEnabled = [
  // 'dev:simpleLoadCfg:cfg',
];

// sync fns (info patrz poszczegolne modoły):
var simpleLoadSync = function simpleLoadSync(name) {
  return simpleLoadCfg(name);
};
var remoteLoadSync = function remoteLoadSync(fullPath, name) {
  return remoteLoadCfg(fullPath, name);
};
var loadSync = function loadSync(globalPath, name) {
  return loadCfg(globalPath, name);
};
var show = function show(width, color, name, obj) {
  return showRawCfg(width, color, name, obj);
};

// simple load PROMISED
var simpleLoad = function simpleLoadPromisfied(name) {
  return new Promise(function (resolve, reject) {
    var cfg = simpleLoadCfg(name);
    if (cfg) resolve(cfg);else reject(new Error('q-mod-config-simpleLoad - Not found config file: "' + name + '" in cwd!'));
  });
};

// remote load PROMISED
var remoteLoad = function remoteLoadPromisfied(fullPath, name) {
  return new Promise(function (resolve, reject) {
    var cfg = remoteLoadCfg(fullPath, name);
    if (cfg) resolve(cfg);else reject(new Error('q-mod-config-remoteLoad - Not found config file: "' + name + '" in "' + fullPath + '"'));
  });
};

// load PROMISED
var load = function loadPromisfied(globalPath, name) {
  return new Promise(function (resolve, reject) {
    var cfg = loadCfg(globalPath, name);
    if (cfg) resolve(cfg);else reject(new Error('q-mod-config-basic - load() Not found config file: "' + name + '" in cwd!'));
  });
};

// module API:
module.exports = {
  simpleLoad: simpleLoad,
  simpleLoadSync: simpleLoadSync,
  remoteLoad: remoteLoad,
  remoteLoadSync: remoteLoadSync,
  show: show,
  load: load,
  loadSync: loadSync
};