'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var c = require('bragi');
// bragi logger
c.options.groupsEnabled = [
  // 'dev:pathGetByCwdAndName',
];

///////////////////////////// generateCommandCfgLoadMsg() /////////////////
/**
 * generateCommandCfgLoadMsg - helper fn do generowania msg dla cli,
 * informujący który command cfg został załadowany czy w cwd czy z qroot.
 * @param  {obj} cmdCfg   command config obj
 * @param  {obj} props    thisScript config obj
 * @return {str}          msg string do wyswietlenia
 */
var generateCommandCfgLoadMsg = function generateCommandCfgLoadMsg(cmdCfg, props) {
  var delimiter = props.options.thisScript.delimiter;
  var commandScriptConfigName = props.options.commandScriptConfigName;
  var msg = void 0;
  var commandCfgLoadMsg = void 0;

  var _cmdCfg = (0, _slicedToArray3.default)(cmdCfg, 2);

  var commandCfgStatus = _cmdCfg[0];
  var commandCfgFromWhere = _cmdCfg[1];


  if (commandCfgStatus === 'ok') {
    msg = commandCfgFromWhere === 'remote' ? 'qroot' : commandCfgFromWhere === 'cwd' ? 'cwd' : 'ani remote ani qroot/remote';
    commandCfgLoadMsg = delimiter + ' Loaded Command Config: "' + commandScriptConfigName + '" from "' + msg + '".';
  } else {
    commandCfgLoadMsg = delimiter + ' Loaded Command Config - "' + commandCfgStatus + '"!';
  }
  return commandCfgLoadMsg;
};

// module API::
module.exports = {
  generateCommandCfgLoadMsg: generateCommandCfgLoadMsg
};