'use strict';

var _require = require('./q-mod-config-simple');

var simpleLoadCfg = _require.simpleLoadCfg;

var _require2 = require('./q-mod-config-remote');

var remoteLoadCfg = _require2.remoteLoadCfg;

var c = require('bragi');
var fp = require('lodash/fp');

// bragi logger
c.options.groupsEnabled = [
  // 'dev:simpleLoadCfg:cfg',
];

/**
 * loadCfg - szuka najpierw o podanej nazwie cfg w cwd,
 *           jeżeli go nieznajdzie, przeszukuje podaną ścieżkę
 *           globalPath do configu globalnego. Gdy to zwiedzie zwraca
 *           arr z informacją ['not-ok'];
 *           Zwraca arr z informacjami:
 *           [
 *             status, // 'ok' lub 'not-ok' - czy odnalazl configi
 *             where,   // 'cwd' lub 'remote' - gdzie odnalazł config
 *             cfgObj   // właściwy obj z configiem
 *           ]
 * @param  {str} globalPath   path to global cfg
 * @param  {str} name         file name of cfg
 * @return {arr}              [status, where, cfgObj]
 */
var loadCfg = fp.curry(function loadCfg(globalPath, name) {
  var status = undefined;
  var whereFrom = undefined;

  var cfgFromCwd = simpleLoadCfg(name);
  if (cfgFromCwd === undefined) {
    status = 'not-ok';
  } else {
    status = 'ok';
    whereFrom = 'cwd';
    var cfgToReturnFromCwd = [status, whereFrom, cfgFromCwd];
    return cfgToReturnFromCwd;
  }

  var cfgFromRemote = remoteLoadCfg(globalPath, name);
  if (cfgFromRemote === undefined) {
    status = 'not-ok';
    var cfgToReturnFromRemote = [status];
    return cfgToReturnFromRemote;
  } else {
    status = 'ok';
    whereFrom = 'remote';
    var _cfgToReturnFromRemote = [status, whereFrom, cfgFromRemote];
    return _cfgToReturnFromRemote;
  }
});

// module API::
module.exports = {
  loadCfg: loadCfg
};