'use strict';

var _require = require('q-mod-myfs');

var readJSON = _require.readJSON;
var ifExists = _require.ifExists;

/**
 * ifExistsCfg sprawdza czy istnieje plig cfg w danej scieżce
 * @param  {str} path   scieżka do pliku
 * @return {bool}       true / false
 */

function ifExistsCfg(path) {
  if (ifExists(path) === 'file') return true;else return false;
}

/**
 * readCfg wczytuje i zwraca obj z plikiem cfg
 * @param  {str} path   scieżka do pliku
 * @return {obj}        obj z cfg-em
 */
function readCfg(path) {
  try {
    if (ifExists(path)) return Object.assign({}, readJSON(path));
  } catch (ex) {
    throw new Error('q-mod-config - ' + readCfg.name + '(): ' + ex);
  }
}

// module API::
module.exports = {
  readCfg: readCfg,
  ifExistsCfg: ifExistsCfg
};