'use strict';

var _require = require('./q-mod-config-readCFG');

var readCfg = _require.readCfg;

var c = require('bragi');
var path = require('path');
var fp = require('lodash/fp');

// bragi logger
c.options.groupsEnabled = [
  // 'dev:remoteLoadCfg',
];

/**
 * remoteLoadCfg - podstawowy skrypt do wczytywania pliku JSON
 *                 w cwd o odpowiedniej nazwie.
 *                 Przydatny do wczytywania dotfilsów i configów.
 *                 (curried)
 * @param  {str} fullPath   sciezka do pliku ale bez nazwy
 * @param  {str} name       nazwa pliku
 * @return {obj}            obj z wczytanego pliku JSON
 */
var remoteLoadCfg = fp.curry(function remoteLoadCfg(fullPath, name) {
  var CFGpath = path.join(fullPath, name);
  c.log('dev:remoteLoadCfg:path', 'path to cfg: ', CFGpath);
  var CFG = readCfg(CFGpath);
  c.log('dev:remoteLoadCfg:cfg', 'content of cfg: ', CFG);
  return CFG;
});

// module API::
module.exports = {
  remoteLoadCfg: remoteLoadCfg
};