'use strict';

var _require = require('q-mod-cliPrinter');

var rawlog = _require.rawlog;

var _require2 = require('q-mod-cliElements');

var header = _require2.header;
var line = _require2.line;

var c = require('bragi');
var fp = require('lodash/fp');

// bragi logger
c.options.groupsEnabled = [
  // 'dev:showCfg',
];

/**
 * showCfg - przygotowuje stringa z zawartoscia cfg do wyswietlenia.
 *           Obudowuje go w nagłówek i stopkę o odpowiedniej szerokości.
 *           (curried)
 * @param  {int} width szerokość
 * @param  {str} color kolor wg wykazu w q-mod-cliPrinter
 * @param  {str} name  nazwa w nagłówku - z regóły nazwa pliku cfg
 * @param  {obj} obj   z zawartością cfg
 * @return {str}      str do druku
 */
var showRawCfg = fp.curry(function showRawCfg(width, color, name, obj) {
  c.log('dev:showCfg:width', 'defoult width: ', width);
  c.log('dev:showCfg:color', 'defoult color: ', color);
  c.log('dev:showCfg:name', 'defoult name: ', name);
  var cfgRawPrintHeader = header(width, name);
  var cfgRawPrintContent = JSON.stringify(obj, null, 2);
  var cfgRawPrintFooter = line(width, 'dash');
  var payload = cfgRawPrintHeader + '\n' + cfgRawPrintContent + '\n' + cfgRawPrintFooter + '\n';
  return rawlog(color, payload);
});

// module API::
module.exports = {
  showRawCfg: showRawCfg
};